datablock TSShapeConstructor(BlockAlphaRDts)
{
	baseShape  = "./BlockAlphaR.dts";
	sequence0  = "./BlockAlphaR_root.dsq root";

	sequence1  = "./BlockAlphaR_walk.dsq run";
	sequence2  = "./BlockAlphaR_running.dsq walk";
	sequence3  = "./BlockAlphaR_back.dsq back";
	sequence4  = "./BlockAlphaR_walk.dsq side";

	sequence5  = "./BlockAlphaR_stands.dsq crouch";
	sequence6  = "./BlockAlphaR_running.dsq crouchRun";
	sequence7  = "./BlockAlphaR_Back.dsq crouchBack";
	sequence8  = "./BlockAlphaR_running.dsq crouchSide";

	sequence9  = "./BlockAlphaR_look.dsq look";
	sequence10 = "./BlockAlphaR_headside.dsq headside";
	sequence11 = "./BlockAlphaR_root.dsq headUp";

	sequence12 = "./BlockAlphaR_jump.dsq jump";
	sequence13 = "./BlockAlphaR_jump.dsq standjump";
	sequence14 = "./BlockAlphaR_fall.dsq fall";
	sequence15 = "./BlockAlphaR_land.dsq land";

	sequence16 = "./BlockAlphaR_armAttack.dsq armAttack";
	sequence17 = "./BlockAlphaR_armReadyLeft.dsq armReadyLeft";
	sequence18 = "./BlockAlphaR_armReadyRight.dsq armReadyRight";
	sequence19 = "./BlockAlphaR_armReadyBoth.dsq armReadyBoth";
	sequence20 = "./BlockAlphaR_spearready.dsq spearready";  
	sequence21 = "./BlockAlphaR_spearThrow.dsq spearThrow";

	sequence22 = "./BlockAlphaR_talk.dsq talk";  

	sequence23 = "./BlockAlphaR_death1.dsq death1"; 
	
	sequence24 = "./BlockAlphaR_root.dsq shiftUp";
	sequence25 = "./BlockAlphaR_vvv.dsq shiftDown";
	sequence26 = "./BlockAlphaR_root.dsq shiftAway";
	sequence27 = "./BlockAlphaR_root.dsq shiftTo";
	sequence28 = "./BlockAlphaR_root.dsq shiftLeft";
	sequence29 = "./BlockAlphaR_root.dsq shiftRight";
	sequence30 = "./BlockAlphaR_root.dsq rotCW";
	sequence31 = "./BlockAlphaR_root.dsq rotCCW";

	sequence32 = "./BlockAlphaR_crouched.dsq undo";
	sequence33 = "./BlockAlphaR_root.dsq plant";

	sequence34 = "./BlockAlphaR_sit.dsq sit";

	sequence35 = "./BlockAlphaR_armAttack.dsq wrench";

   sequence36 = "./BlockAlphaR_activate.dsq activate";
   sequence37 = "./BlockAlphaR_activate2.dsq activate2";

   sequence38 = "./BlockAlphaR_root.dsq leftrecoil";
};      

datablock AudioProfile(BlockAlphaRDeathSound)
{
	fileName = "./death1.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(BlockAlphaRPainSound)
{
    fileName = "./pain.wav";
    description = AudioClose3d;
    preload = true;
};
datablock AudioProfile(BlockAlphaRRunSound)
{
    fileName = "./run.wav";
    description = AudioClose3d;
    preload = true;
};
datablock fxDTSBrickData (BrickBlockAlphaRBot_HoleSpawnData)
{
	brickFile = "Add-ons/Bot_Hole/4xSpawn.blb";
	category = "Special";
	subCategory = "Holes";
	uiName = "BlockAlphaR Hole";
	iconName = "Add-Ons/Bot_BlockAlphaR/rc";

	bricktype = 2;
	cancover = 0;
	orientationfix = 1;
	indestructable = 1;

	isBotHole = 1;
	holeBot = "BlockAlphaRHoleBot";
};

datablock PlayerData(BlockAlphaRHoleBot : PlayerStandardArmor)
{
	shapeFile = "./BlockAlphaR.dts";
	uiName = "Andre(Riot_Cop)";
	minJetEnergy = 0;
   cameramaxdist = 2;
   cameraVerticalOffset = 1;
   cameraHorizontalOffset = 0.8;
   cameraTilt = 0.2;
   maxfreelookangle = 3;
	jetEnergyDrain = 0;
	canJet = 0;
	maxItems   = 10;
	maxWeapons = 5;
	maxTools = 5;

	rideable = false;
	canRide = true;
	paintable = true;

   useCustomPainEffects = true;
   PainSound			= BlockAlphaRPainSound;
   DeathSound			= BlockAlphaRDeathSound;

	mass = 100;
	drag = 0.02;//0.02
	density = 0.80;//0.6
	runSurfaceAngle = 70;
	jumpSurfaceAngle = 70;
    runForce = 90 * 90;
	maxForwardSpeed = 7;
	maxBackwardSpeed = 5;
	maxSideSpeed = 7;

   maxForwardCrouchSpeed = 11;
   maxBackwardCrouchSpeed = 7;
   maxSideCrouchSpeed = 7;

   maxForwardProneSpeed = 2;
   maxBackwardProneSpeed = 2;
   maxSideProneSpeed = 2;

	attackpower = 13;

	maxdamage = 140;//Bot Health
	jumpSound = "";//Removed due to bots jumping a lot

	crouchBoundingBox	= vectorScale("3.5 3.5 1.8", 4); //"2.5 2.5 2.4";
	sitBoundingBox	= vectorScale("3.5 3.5 1.5", 4); //"2.5 2.5 2.4";
	
	//Hole Attributes
	isHoleBot = 1;

	//Spawning option
	hSpawnTooClose = 0;//Doesn't spawn when player is too close and can see it
	  hSpawnTCRange = 8;//above range, set in brick units
	hSpawnClose = 0;//Only spawn when close to a player, can be used with above function as long as hSCRange is higher than hSpawnTCRange
	  hSpawnCRange = 32;//above range, set in brick units

	hType = Friendly; //Enemy,Friendly, Neutral
	  hNeutralAttackChance = 0; //0 to 100, Chance that this type will attack neutral bots, ie horses/vehicles/civilians
	//can have unique types, nazis will attack zombies but nazis will not attack other bots labeled nazi
	hName = "BlockAlphaR";//cannot contain spaces
	hTickRate = 3000;
	
	//Wander Options
	hWander = 1;//Enables random walking
	  hSmoothWander = 1;//This is in addition to regular wander, makes them walk a bit longer, and a bit smoother
	  hReturnToSpawn = 1;//Returns to spawn when too far
	  hSpawnDist = 80;//Defines the distance bot can travel away from spawnbrick
	  hGridWander = 0;//Locks the bot to a grid, overwrites other settings
	
	//Searching options
	hSearch = 1;//Search for Players
	  hSearchRadius = 150;//in brick units
	  hSight = 1;//Require bot to see player before pursuing
	  hStrafe = 1;//Randomly strafe while following player
	hSearchFOV = 0;//if enabled disables normal hSearch
	  hFOVRange = 0.7; // determines the angle we can see the player at, 0.7 is about normal fov for players, if 0 we can see all in front, if 1 we could only see someone perfectly ahead, can be negative
	  // hFOVRadius = 6; // no longer used, we now use searchRadius
	  hHearing = 2;//If it hears a player it'll look in the direction of the sound

	  hAlertOtherBots = 3;//Alerts other bots when he sees a player, or gets attacked

	//Attack Options
	hMelee = 0;//Melee
	  hAttackDamage = 15;//Melee Damage
	hShoot = 1;
	  hWep = "gunItem";
	  hShootTimes = 5;//Number of times the bot will shoot between each tick
	  hMaxShootRange = 300;//The range in which the bot will shoot the player
	  hAvoidCloseRange = 2;//
		hTooCloseRange = 7;//in brick units

	//Misc options
	hActivateDirection = 0; // 0 1 2, determines the direction you have to face the bot to activate him, both, front back
	hMoveSlowdown = 0; // bool, determines wether the bot will slow down when following enemies
	hAvoidObstacles = 1;
	hSuperStacker = 0;//When enabled makes the bots stack a bit better, in other words, jumping on each others heads to get to a player
	hSpazJump = 0;//Makes bot jump when the user their following is higher than them

	hAFKOmeter = 1;//Determines how often the bot will wander or do other idle actions, higher it is the less often he does things

	hIdle = 1;// Enables use of idle actions, actions which are done when the bot is not doing anything else
	  hIdleAnimation = 0;//Plays random animations/emotes, sit, click, love/hate/etc
	  hIdleLookAtOthers = 1;//Randomly looks at other players/bots when not doing anything else
	  hSpasticLook = 1;//Makes them look around their environment a bit more.
	hEmote = 1;
};

function BlockAlphaRHoleBot::onAdd(%this,%obj)
{
	armor::onAdd(%this,%obj);
	%color[%a++] = "1 1 1 1";
	//Appearance BlockAlphaR

	%choice = getRandom(1,%a);
	%obj.setNodeColor("ALL",%color[%choice]);
	%obj.chestColor =  %color[%choice];
	scheduleNoQuota(10,%obj,delayBlockAlphaRCheck,%obj);
}

function BlockAlphaRHoleBot::onBotLoop( %this, %obj )
{
	// echo( "BlockAlphaR onLoop" );
	// parent::onBotLoop( %this, %obj );
	//Called every cycle
	//Useful for doing unique behaviors during normal loop
}

function BlockAlphaRHoleBot::onBotCollision( %this, %obj, %col, %normal, %speed )
{
	// echo( "BlockAlphaR onCollision" );
	//Called once every second the object is colliding with something
}

function BlockAlphaRHoleBot::onBotFollow( %this, %obj, %targ )
{
	// echo( "BlockAlphaR onFollow" );
	//Called when the target follows a player each tick, or is running away
}

function BlockAlphaRHoleBot::onBotDamage( %this, %obj, %source, %pos, %damage, %type )
{
	// echo( "BlockAlphaR onDamage" );
	//Called when the bot is being damaged
}

package BotFollowPlayerPackage
{
	function AIPlayer::hLoop(%obj)
	{
		Parent::hLoop(%obj);

		if(!isObject(%obj.hFollowingNoDamage))
			%obj.hFollowingNoDamage = 0;

		if(%obj.hFollowingNoDamage == 0 && %obj.hFollowType != 1 && %obj.hFollowType != 2)
			return;

		if(%obj.hFollowingNoDamage == 0 && (%obj.hFollowType == 1 || %obj.hFollowType == 2))
		{
			%obj.followPlayer(%obj.hFollowType, %obj.hFollowingNoDamage.bl_id, %obj.hKeepFollowing, %obj.hFollowingNoDamage);
			return;
		}

		%following = %obj.hFollowingNoDamage.player;

		if(!isObject(%following) && !%obj.hKeepFollowing)
			%obj.hFollowingNoDamage = 0;

		if(%following.client.isDead && !%obj.hKeepFollowing)
			%obj.hFollowingNoDamage = 0;

		%obj.followPlayer(%obj.hFollowType, %obj.hFollowingNoDamage.bl_id, %obj.hKeepFollowing, %obj.hFollowingNoDamage);
	}

	function GameConnection::onDeath(%this, %killerPlayer, %killerClient, %damageType, %damageLoc)
	{
		Parent::onDeath(%this, %killerPlayer, %killerClient, %damageType, %damageLoc);
		%this.isDead = true;
	}

	function GameConnection::spawnPlayer(%this, %spawn)
	{
		%this.isDead = false;
		return Parent::spawnPlayer(%this, %spawn);
	}
};
package noShootCrouch {
    function Armor::onTrigger(%db, %this, %slot, %pos) {
        if(%slot == 3 && isObject(%this.getMountedImage(%pos?0:2))) {
            %this.mountImage(%this.getMountedImage(%pos?0:2), %pos*2);
            %this.unMountImage(%pos?0:2);
        }
        parent::onTrigger(%db, %this, %slot, %pos);
    }
};
activatePackage(noShootCrouch);
